// PRUSA Mendel  
// X-Endstop holder
// Used to attach endstop to 8mm X-rods
// GNU GPL v3
// Josef Průša
// josefprusa@me.com
// prusadjs.cz
// modified version creation Coen Roos 14 dec. 2012
// modified version creation Robert Moro 16 dec. 2012


/**
 * @id X-endstop-holder
 * @name X-Endstop holder
 * @category Printed
 * @using 1 m3x20xhex
 * @using 1 m3nut
 * @using 2 m3washer
 */

m3_nut_diameter_horizontal = 6.1;
m8_diameter=9;
m3_diameter=3.6;
outer_diameter = m8_diameter/2+3.3;
opening_size = m8_diameter-1.5; //openingsize
module endstop()
{
	// Rodclamp
	rodclamp(0);

	// Rodclamp
 	rotate(a=180, v=[1,0,0]) translate([0,-65,-10]) rodclamp(1);

	// Bridge between rodclamps
	translate([0,15,0])
	{
		difference()
		{
			cube([5,38,10]);
			// Holes for endstop switch
			union()
			{
				translate([-3,4,5]) rotate([0,90,0])
				{
					cylinder(h =12, r = m3_diameter/2, $fn = 10);
					translate([0,20,0])cylinder(h =12, r = m3_diameter/2, $fn = 10);
				}
			}
		}
	}

}

module rodclamp(switch)
{
 	difference()
	{
		union()
		{
			translate([outer_diameter, outer_diameter, 0]) cylinder(h =10, r = outer_diameter, $fn = 36);
			translate([outer_diameter, 0, 0]) cube([15.5,outer_diameter*2,10]);
			translate([17, 17.5, 5]) rotate([90, 0, 0]) cylinder(h =5, r = 5.77, $fn = 6);
			translate ([0,7,0]) cube([5,10,10]);
		}
		translate([9, outer_diameter-opening_size/2, -1]) cube([18,opening_size,20]);
		translate([outer_diameter, outer_diameter, -1]) cylinder(h =20, r = m8_diameter/2, $fn = 18);
		translate([17, 19.5, 5]) rotate([90, 0, 0]) cylinder(h =5, r = m3_nut_diameter_horizontal/2, $fn = 6);
		//Securing hole
		translate([17, 17, 5]) rotate([90, 0, 0]) cylinder(h =20, r = m3_diameter/2, $fn = 10);
	   }
}

endstop();

//rodclamp(0);